Program TEST_TEXT2EXE_ICA;
(* TXT2EXE Interprogram-Communication-Area Test-Program *)

USES dos; { wg TYPE Registers }

TYPE
  TXT2EXEMode = (Zeile, Seite, UeberSchrift);

  FUNCTION TXT2EXEset(mode : TXT2EXEMode; value : LongInt) : Boolean;
(*************************************************************************)
(*                                                                       *)
(*  Setzt Zeile, Seite, Ueberschrift fr die Stelle an der mit TXT2EXE   *)
(*  erzeugte Programme mit der Anzeige beginnen sollen. Jedoch mu       *)
(*  zuvor das TSR T2EICA (600 Bytes) installiert sein.                   *)
(*                                                                       *)
(*    AUFRUF INT 2Fh                                                     *)
(*      AX = 5547h                                                       *)
(*      Bh = Function : 0 -- installed // 1 -- set val // 2 -- get val   *)
(*      Bl = Modus : 0 -- Zeile // 1 -- Seite // 2 -- Ueberschrift       *)
(*      CX = Wert div 65536 (Hi-Word)                                    *)
(*      DX = Wert mod 65536 (Lo-Word)                                    *)
(*                                                                       *)
(*    Zurck :                                                           *)
(*      AX = 524Eh wenn OK                                               *)
(*                                                                       *)
(*************************************************************************)
  CONST
    TXT2EXE_ICA_KENNUNG = $5547;   { "GU" }
    TXT2EXE_ICA_ANTWORT_OK = $524e;{ "NR" }
  TYPE
    Long = RECORD
             l,h : Word;
           END;
  VAR
    r : registers;
  BEGIN
    r.ax := TXT2EXE_ICA_KENNUNG;                 { Kennung in AX }
    r.bh := 0;                                   { ICA installiert ? }
    intr($2f, r);
    IF r.ax = TXT2EXE_ICA_ANTWORT_OK THEN        { OK=Antwort }
      BEGIN
        CASE mode OF
          Zeile : r.bl := 0;                     { Zeile : bl = 0 }
          Seite : r.bl := 1;                     { Seite : bl = 1 }
          UeberSchrift : r.bl := 2;              { Ueberschrift : bl = 2 }
        END;
        r.bh := 1;                               { Funktion PUT-Value to ICA }
        r.ax := TXT2EXE_ICA_KENNUNG;
        r.cx := long(value).h;                   { Typecasting longint --> word }
        r.dx := long(value).l;                   { Typecasting longint --> word }
        intr($2f, r);
        IF r.ax = TXT2EXE_ICA_ANTWORT_OK THEN    { OK=Antwort }
          TXT2EXEset := True                     { Alles glatt gegangen }
        ELSE
          TXT2EXEset := False                    { schiefgeganen ... }
      END
    ELSE
      TXT2EXEset := False;                       { T2EICA nicht installiert }
  END;


begin

  { do or call something }

  TXT2EXEset(Ueberschrift,5);      { ein mit TXT2EXE erstelltes Programm }
                                   { beinnt mit der Anzeige bei der      }
                                   { fnften berschrift                 }

  { do or call something }

  TXT2EXEset(Zeile,342);           { ein mit TXT2EXE erstelltes Programm }
                                   { beinnt mit der Anzeige ab Zeile 342 }
end.
